OGRE: Ogre::ScriptCompilerManager Class Reference - OGRE Documentation

# Ogre::ScriptCompilerManager Class Reference

Manages threaded compilation of scripts. More...

`#include <OgreScriptCompiler.h>`

Inheritance diagram for Ogre::ScriptCompilerManager:

[legend]

List of all members.

## Public Member Functions
| ScriptCompilerManager ()
virtual | ~ScriptCompilerManager ()
void | setListener (ScriptCompilerListener *listener)
| Sets the listener used for compiler instances.
ScriptCompilerListener * | getListener ()
| Returns the currently set listener used for compiler instances.
void | addTranslatorManager (ScriptTranslatorManager *man)
| Adds the given translator manager to the list of managers.
void | removeTranslatorManager (ScriptTranslatorManager *man)
| Removes the given translator manager from the list of managers.
void | clearTranslatorManagers ()
| Clears all translator managers.
ScriptTranslator * | getTranslator (const AbstractNodePtr &node)
| Retrieves a ScriptTranslator from the supported managers.
const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this class. Remarks: This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader. Returns: A list of file patterns, in the order they should be searched in.
void | parseScript (DataStreamPtr &stream, const String &groupName)
  | Parse a script file. Parameters:
  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.
Real | getLoadingOrder (void) const
| Gets the relative loading order of scripts of this type. Remarks: There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order. Returns: A value representing the relative loading order of these scripts compared to other script users, where higher values load later.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static ScriptCompilerManager & | getSingleton (void)
| Override standard Singleton retrieval.
static ScriptCompilerManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Static Protected Attributes
static T * | ms_Singleton
## Private Member Functions
| OGRE_THREAD_POINTER (ScriptCompiler, mScriptCompiler)
## Private Attributes
OGRE_AUTO_MUTEX StringVector | mScriptPatterns
ScriptCompilerListener * | mListener
std::vector < ScriptTranslatorManager * > | mManagers
ScriptTranslatorManager * | mBuiltinTranslatorManager

## Detailed Description

Manages threaded compilation of scripts.

This script loader forwards scripts compilations to a specific compiler instance.

Definition at line 418 of file OgreScriptCompiler.h.

## Constructor & Destructor Documentation

Ogre::ScriptCompilerManager::ScriptCompilerManager | ( |  | ) |

virtual Ogre::ScriptCompilerManager::~ScriptCompilerManager | ( |  | ) | `[virtual]`

## Member Function Documentation

Ogre::ScriptCompilerManager::OGRE_THREAD_POINTER | ( | ScriptCompiler | ,
|  | mScriptCompiler |  |
| ) |  |  | `[private]`

void Ogre::ScriptCompilerManager::setListener | ( | ScriptCompilerListener * | listener | ) |

Sets the listener used for compiler instances.

ScriptCompilerListener* Ogre::ScriptCompilerManager::getListener | ( |  | ) |

Returns the currently set listener used for compiler instances.

void Ogre::ScriptCompilerManager::addTranslatorManager | ( | ScriptTranslatorManager * | man | ) |

Adds the given translator manager to the list of managers.

void Ogre::ScriptCompilerManager::removeTranslatorManager | ( | ScriptTranslatorManager * | man | ) |

Removes the given translator manager from the list of managers.

void Ogre::ScriptCompilerManager::clearTranslatorManagers | ( |  | ) |

Clears all translator managers.

ScriptTranslator* Ogre::ScriptCompilerManager::getTranslator | ( | const AbstractNodePtr & | node | ) |

Retrieves a ScriptTranslator from the supported managers.

const StringVector& Ogre::ScriptCompilerManager::getScriptPatterns | ( | void |  | ) | const`[virtual]`

Gets the file patterns which should be used to find scripts for this class.

Remarks:
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns:
  A list of file patterns, in the order they should be searched in.

Implements Ogre::ScriptLoader.

void Ogre::ScriptCompilerManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName |
| ) |  |  | `[virtual]`

Parse a script file.

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

Implements Ogre::ScriptLoader.

Real Ogre::ScriptCompilerManager::getLoadingOrder | ( | void |  | ) | const`[virtual]`

Gets the relative loading order of scripts of this type.

Remarks:
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns:
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

Implements Ogre::ScriptLoader.

static ScriptCompilerManager& Ogre::ScriptCompilerManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< T >.

static ScriptCompilerManager* Ogre::ScriptCompilerManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< T >.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

OGRE_AUTO_MUTEX StringVector Ogre::ScriptCompilerManager::mScriptPatterns`[private]`

Definition at line 424 of file OgreScriptCompiler.h.

ScriptCompilerListener* Ogre::ScriptCompilerManager::mListener`[private]`

Definition at line 427 of file OgreScriptCompiler.h.

std::vector<ScriptTranslatorManager*> Ogre::ScriptCompilerManager::mManagers`[private]`

Definition at line 430 of file OgreScriptCompiler.h.

ScriptTranslatorManager* Ogre::ScriptCompilerManager::mBuiltinTranslatorManager`[private]`

Definition at line 433 of file OgreScriptCompiler.h.

template<typename T>

T* Ogre::Singleton< T >::ms_Singleton`[static, protected, inherited]`

Definition at line 61 of file OgreSingleton.h.

Referenced by Ogre::Singleton< Ogre::FontManager >::getSingleton(), Ogre::Singleton< Ogre::FontManager >::getSingletonPtr(), Ogre::Singleton< Ogre::FontManager >::Singleton(), and Ogre::Singleton< Ogre::FontManager >::~Singleton().

The documentation for this class was generated from the following file:

- OgreScriptCompiler.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:36:40 2009